

import java.awt.*;
import java.awt.event.*;
import com.javathings.math.*;
import java.util.*;

public class SpeedTest extends Frame implements ActionListener, WindowListener, KeyListener{

	Cursor WAIT_CURSOR, DEF_CURSOR;
	TextField func, xmin, xmax, iter;
	Label lbl1, lbl2, lbl3, lbl4;
	Button but;
	TextArea ta;
	
	public SpeedTest()
	{
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();

		ta = new TextArea( 5, 20 );
		func = new TextField( "xcos(x)" , 4 );
		xmin = new TextField( "-10" , 4 );
		xmax = new TextField( "10" , 4 );
		iter = new TextField( "1000" , 4 );

		but = new Button( "Start" );
		lbl1 = new Label( "Function:" );
		lbl2 = new Label( "xmin:" );
		lbl3 = new Label( "xmax:" );
		lbl4 = new Label( "iterations:" );

		DEF_CURSOR = new Cursor( Cursor.DEFAULT_CURSOR );
		WAIT_CURSOR = new Cursor( Cursor.WAIT_CURSOR );

		setLayout( gb );

		setConstr( gbc, 0, 0, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( lbl1 , gbc );

		setConstr( gbc, 1, 0, 5, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( func , gbc );

		setConstr( gbc, 0, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( lbl2 , gbc );

		setConstr( gbc, 1, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( xmin , gbc );

		setConstr( gbc, 2, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( lbl3 , gbc );

		setConstr( gbc, 3, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( xmax , gbc );

		setConstr( gbc, 4, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( lbl4 , gbc );

		setConstr( gbc, 5, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( iter , gbc );

		setConstr( gbc, 0, 2, 6, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( but , gbc );

		setConstr( gbc, 0, 3, 6, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 5, 5, 5, 5 );	
		gb.setConstraints( ta , gbc );

		but.addActionListener( this );
		func.addKeyListener( this );
		this.addWindowListener( this );

		this.setBackground( Color.gray );
		ta.setBackground( Color.lightGray );
		but.setBackground( Color.lightGray );
		func.setBackground( Color.lightGray );
		xmin.setBackground( Color.lightGray );
		xmax.setBackground( Color.lightGray );
		iter.setBackground( Color.lightGray );

		lbl1.setForeground( Color.white );
		lbl2.setForeground( Color.white );
		lbl3.setForeground( Color.white );
		lbl4.setForeground( Color.white );

		Font f = new Font( "Serif" , 1, 12 );
		ta.setFont( f );
		func.setFont( f );
	
		this.setTitle( "SpeedTest - Eval.class" );

		add( lbl1 );
		add( lbl2 );
		add( lbl3 );
		add( lbl4 );
		add( but );
		add( ta );
		add( func );
		add( iter );
		add( xmin );
		add( xmax );
	}
	
	public void 
	actionPerformed( ActionEvent e )
	{
		runTest();
	}

	public void 
	keyPressed(KeyEvent e) 
	{
		if( e.getKeyCode() == KeyEvent.VK_ENTER )
		{
			runTest();
		}
	}

	public void 
	windowClosing(WindowEvent e)
	{
		this.setVisible( false );
		System.exit( 0 );
	}

	public static void 
	main( String args[] )
	{
		SpeedTest st = new SpeedTest();
		st.pack();
		st.setVisible( true );
	}

	private void 
	setConstr( GridBagConstraints gbc, int x, int y, int w, int h, int wx, int wy, int f, int a, int bottom, int left, int right, int top)
	{
	  	gbc.gridx = x;
	  	gbc.gridy = y;
	  	gbc.gridwidth = w;
	  	gbc.gridheight = h;
	  	gbc.weightx = wx;
	  	gbc.weighty = wy;
	  	gbc.fill = f;
	  	gbc.anchor = a;	
	  	gbc.insets = new Insets( bottom, left, right, top );
	}

	private void
	runTest()
	{	
		String funcstr;
		long before, after;
		double xval, minx, maxx, step;
		Hashtable h;
		Eval e;
		int i, itr;

		waitCursor();
		
		try{
			
			e = new Eval();
			h = new Hashtable( 101 );

			funcstr = func.getText().trim();

			minx = Double.valueOf( xmin.getText().trim() ).doubleValue();
			maxx = Double.valueOf( xmax.getText().trim() ).doubleValue();
			itr = Integer.parseInt( iter.getText().trim() );

			xval = minx;

			step = ( Math.abs( minx ) + Math.abs( maxx ) ) / itr;

			before = (new Date()).getTime();
			
			for( i = 0; i < itr; i++ )
			{
				h.put( "x" , String.valueOf( xval ) );
				e.eval( funcstr , h );
				xval += step;
			}

			after = (new Date()).getTime();
	
			ta.setText( "Function: " + funcstr + "\n" );
			ta.append( "Xmin: " + minx + ", Xmax: " + maxx + "\n" );
			ta.append( "Iterations: " + itr + "\n" );
			ta.append( "Time consumed: " + (after-before) + " milliseconds.\n" );
		}
		catch( Exception ex )
		{
			ta.setText( "Error: " + ex.toString() );
		}
		finally
		{
			e = null;
			h = null;
		}

		defCursor();
	}

	private void 
	waitCursor()
	{
		ta.setCursor( WAIT_CURSOR );
		lbl1.setCursor( WAIT_CURSOR );
		lbl2.setCursor( WAIT_CURSOR );
		lbl3.setCursor( WAIT_CURSOR );
		lbl4.setCursor( WAIT_CURSOR );
		but.setCursor( WAIT_CURSOR );
	}

	private void 
	defCursor()
	{
		ta.setCursor( DEF_CURSOR );
		lbl1.setCursor( DEF_CURSOR );
		lbl2.setCursor( DEF_CURSOR );
		lbl3.setCursor( DEF_CURSOR );
		lbl4.setCursor( DEF_CURSOR );
		but.setCursor( DEF_CURSOR );
	}

	public void windowActivated(WindowEvent e) {}
	public void windowClosed(WindowEvent e)  {}
	public void windowDeactivated(WindowEvent e)  {}
	public void windowDeiconified(WindowEvent e)  {}
	public void windowIconified(WindowEvent e)  {}
	public void windowOpened(WindowEvent e)  {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}

}